package jp.denpa.tomy.opengl_es.wrap;

import javax.microedition.khronos.opengles.GL10;

import jp.denpa.tomy.games.MyView;
import jp.denpa.tomy.games.R;
//import android.content.Context;
import android.content.res.Resources;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.opengl.GLUtils;


//テクスチャ管理クラス（１枚単位）
public class GLTexture {
//	private Context context;			//このクラスでContextからgetResoucesするとエラーのち強制終了
	private Bitmap bitmap;
	private int textureName;
	private GL10 gl10;

	//テクスチャの読み込み
	public void LoadTexture(GL10 gl,Resources res,int id){
		gl10=gl;
		//テクスチャに関する処理---------------------------------------
		bitmap =	BitmapFactory.decodeResource(res, id);

		int[] buffers = new int[1];
		//texture夜のメモリを指定数確保
		gl10.glGenTextures(1,buffers,0);
		//テクスチャ名を保存する
		textureName = buffers[0];

	}

	//テクスチャのセット（＆拡大縮小時の画質の設定）
	public void SetTex(int MinBorder,int MagBorder){	//引数：1 縮小時の画質設定  2 拡大時の画質設定
		gl10.glBindTexture(GL10.GL_TEXTURE_2D, textureName);
		GLUtils.texImage2D(GL10.GL_TEXTURE_2D, 0, bitmap, 0);				//テクスチャ確定

		//
		//GL10.GL_NEARESTは処理が早いが画質は悪い
		//GL10.GL_LINEARは処理は遅いが画質は良い
		//拡大縮小時の処理を指定
		gl10.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MIN_FILTER, MinBorder);
		gl10.glTexParameterf(GL10.GL_TEXTURE_2D, GL10.GL_TEXTURE_MAG_FILTER, MagBorder);

		//ビットマップを廃棄
		bitmap.recycle();
	}

	public int getTexName(){
		return textureName;
	}

	//開放処理
	public void Release(){}

}
